# Contributing to Handsontable

Your contributions to this project are very welcome. If you want to fix a bug or propose a new feature, you can open a new Pull Request but first make sure it follows these general rules:

1. Sign this [Contributor License Agreement](https://goo.gl/forms/yuutGuN0RjsikVpM2) to allow us to publish your changes to the code.
2. Make your changes on a separate branch. This will speed up the merging process.
3. Always make the target of your pull request the `develop` branch, not `master`.
4. Do not edit files in dist/ directory.
5. **Important: For any change you make, please add at least one test case** in `tests/`. That will help us understand the issue and make sure that it stays fixed forever.
6. Please review our [coding style](https://github.com/handsontable/handsontable/wiki/Coding-style) for instructions on how to properly style the code.
7. Add a thorough description of all the changes.

Thank you for your commitment!

## Team rules

The Handsontable team utilizes Git-Flow. Read more - [How we use Git-Flow](https://github.com/handsontable/handsontable/wiki/How-we-use-Git-Flow)