import { ElementRef, EventEmitter, NgZone, AfterContentInit, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { HotRegisterer } from './hot-registerer.service';
import { HotHelper } from './hot-settings.utils';
import { HotColumnComponent } from './hot-column.component';
export declare class HotTableComponent implements AfterContentInit, OnChanges, OnDestroy, OnInit {
    private el;
    private _ngZone;
    private _hotRegisterer;
    private _hotHelper;
    private hotInstance;
    private container;
    private columnsComponents;
    settings: object;
    hotId: string;
    allowEmpty: boolean;
    allowHtml: boolean;
    allowInsertColumn: boolean;
    allowInsertRow: boolean;
    allowInvalid: boolean;
    allowRemoveColumn: boolean;
    allowRemoveRow: boolean;
    autoColumnSize: boolean | object;
    autoComplete: any[];
    autoRowSize: boolean | object;
    autoWrapCol: boolean;
    autoWrapRow: boolean;
    bindRowsWithHeaders: boolean | string;
    cell: any[];
    cells: (row: number, column: number, prop: object) => object;
    checkedTemplate: boolean | string;
    className: string | string[];
    colHeaders: boolean | string[] | ((column: number) => string);
    collapsibleColumns: boolean | object[];
    columnHeaderHeight: number | number[];
    columns: object[] | ((column: number) => object);
    columnSorting: boolean | object;
    columnSummary: object;
    colWidths: number | number[] | string | ((column: number) => number);
    commentedCellClassName: string;
    comments: boolean | object[];
    contextMenu: boolean | object | object[];
    copyable: boolean;
    copyColsLimit: number;
    copyPaste: boolean;
    copyRowsLimit: number;
    correctFormat: boolean;
    currentColClassName: string;
    currentHeaderClassName: string;
    currentRowClassName: string;
    customBorders: boolean | object[];
    data: any[];
    dataSchema: object;
    dateFormat: string;
    debug: boolean;
    defaultDate: string;
    disableVisualSelection: boolean | string | string[];
    dropdownMenu: boolean | object | object[];
    editor: boolean | string | (() => void);
    enterBeginsEditing: boolean;
    enterMoves: object | (() => void);
    fillHandle: boolean | string | object;
    filter: boolean;
    filteringCaseSensitive: boolean;
    filters: boolean;
    fixedColumnsLeft: number;
    fixedRowsBottom: number;
    fixedRowsTop: number;
    format: string;
    formulas: boolean;
    fragmentSelection: boolean | string;
    ganttChart: object;
    headerTooltips: boolean | object;
    height: number | (() => number);
    hiddenColumns: boolean | object;
    hiddenRows: boolean | object;
    invalidCellClassName: string;
    label: object;
    language: string;
    manualColumnFreeze: boolean;
    manualColumnMove: boolean | number[];
    manualColumnResize: boolean | number[];
    manualRowMove: boolean | number[];
    manualRowResize: boolean | number[];
    maxCols: number;
    maxRows: number;
    mergeCells: boolean | object[];
    minCols: number;
    minRows: number;
    minSpareCols: number;
    minSpareRows: number;
    multiSelect: boolean;
    nestedHeaders: any[];
    noWordWrapClassName: string;
    observeChanges: boolean;
    observeDOMVisibility: boolean;
    outsideClickDeselects: boolean | ((event: Event) => boolean);
    pasteMode: string;
    persistentState: boolean;
    placeholder: any;
    placeholderCellClassName: string;
    preventOverflow: boolean | string;
    readOnly: boolean;
    readOnlyCellClassName: string;
    renderAllRows: boolean;
    renderer: string | (() => void);
    rowHeaders: boolean | string[] | (() => string);
    rowHeaderWidth: number | number[];
    rowHeights: number | number[] | string | ((row: number) => number);
    search: boolean;
    selectOptions: string[] | number[];
    skipColumnOnPaste: boolean;
    sortByRelevance: boolean;
    sortFunction: (sortOrder: boolean) => void;
    sortIndicator: boolean;
    source: any[] | (() => void);
    startCols: number;
    startRows: number;
    stretchH: string;
    strict: boolean;
    tableClassName: string | string[];
    tabMoves: object;
    title: string;
    trimDropdown: boolean;
    trimRows: boolean | number[];
    trimWhitespace: boolean;
    type: string;
    uncheckedTemplate: boolean | string;
    undo: boolean;
    validator: string | RegExp | (() => void);
    viewportColumnRenderingOffset: number | string;
    viewportRowRenderingOffset: number | string;
    visibleRows: number;
    width: number | (() => number);
    wordWrap: boolean;
    afterAddChild: EventEmitter<any[]>;
    afterBeginEditing: EventEmitter<any[]>;
    afterCellMetaReset: EventEmitter<any[]>;
    afterChange: EventEmitter<any[]>;
    afterChangesObserved: EventEmitter<any[]>;
    afterColumnMove: EventEmitter<any[]>;
    afterColumnResize: EventEmitter<any[]>;
    afterColumnSort: EventEmitter<any[]>;
    afterContextMenuDefaultOptions: EventEmitter<any[]>;
    afterContextMenuHide: EventEmitter<any[]>;
    afterContextMenuShow: EventEmitter<any[]>;
    afterCopy: EventEmitter<any[]>;
    afterCopyLimit: EventEmitter<any[]>;
    afterCreateCol: EventEmitter<any[]>;
    afterCreateRow: EventEmitter<any[]>;
    afterCut: EventEmitter<any[]>;
    afterDeselect: EventEmitter<any[]>;
    afterDestroy: EventEmitter<any[]>;
    afterDetachChild: EventEmitter<any[]>;
    afterDocumentKeyDown: EventEmitter<any[]>;
    afterDropdownMenuDefaultOptions: EventEmitter<any[]>;
    afterDropdownMenuHide: EventEmitter<any[]>;
    afterDropdownMenuShow: EventEmitter<any[]>;
    afterFilter: EventEmitter<any[]>;
    afterGetCellMeta: EventEmitter<any[]>;
    afterGetColHeader: EventEmitter<any[]>;
    afterGetColumnHeaderRenderers: EventEmitter<any[]>;
    afterGetRowHeader: EventEmitter<any[]>;
    afterGetRowHeaderRenderers: EventEmitter<any[]>;
    afterInit: EventEmitter<any[]>;
    afterLoadData: EventEmitter<any[]>;
    afterModifyTransformEnd: EventEmitter<any[]>;
    afterModifyTransformStart: EventEmitter<any[]>;
    afterMomentumScroll: EventEmitter<any[]>;
    afterOnCellCornerDblClick: EventEmitter<any[]>;
    afterOnCellCornerMouseDown: EventEmitter<any[]>;
    afterOnCellMouseDown: EventEmitter<any[]>;
    afterOnCellMouseOver: EventEmitter<any[]>;
    afterOnCellMouseOut: EventEmitter<any[]>;
    afterPluginsInitialized: EventEmitter<any[]>;
    afterRedo: EventEmitter<any[]>;
    afterRemoveCol: EventEmitter<any[]>;
    afterRemoveRow: EventEmitter<any[]>;
    afterRender: EventEmitter<any[]>;
    afterRenderer: EventEmitter<any[]>;
    afterRowMove: EventEmitter<any[]>;
    afterRowResize: EventEmitter<any[]>;
    afterScrollHorizontally: EventEmitter<any[]>;
    afterScrollVertically: EventEmitter<any[]>;
    afterSelection: EventEmitter<any[]>;
    afterSelectionByProp: EventEmitter<any[]>;
    afterSelectionEnd: EventEmitter<any[]>;
    afterSelectionEndByProp: EventEmitter<any[]>;
    afterSetCellMeta: EventEmitter<any[]>;
    afterSetDataAtCell: EventEmitter<any[]>;
    afterSetDataAtRowProp: EventEmitter<any[]>;
    afterTrimRow: EventEmitter<any[]>;
    afterUndo: EventEmitter<any[]>;
    afterUntrimRow: EventEmitter<any[]>;
    afterUpdateSettings: EventEmitter<any[]>;
    afterValidate: EventEmitter<any[]>;
    afterViewportColumnCalculatorOverride: EventEmitter<any[]>;
    afterViewportRowCalculatorOverride: EventEmitter<any[]>;
    beforeAddChild: EventEmitter<any[]>;
    beforeAutofill: EventEmitter<any[]>;
    beforeAutofillInsidePopulate: EventEmitter<any[]>;
    beforeCellAlignment: EventEmitter<any[]>;
    beforeChange: EventEmitter<any[]>;
    beforeChangeRender: EventEmitter<any[]>;
    beforeColumnMove: EventEmitter<any[]>;
    beforeColumnResize: EventEmitter<any[]>;
    beforeColumnSort: EventEmitter<any[]>;
    beforeContextMenuSetItems: EventEmitter<any[]>;
    beforeCopy: EventEmitter<any[]>;
    beforeCreateCol: EventEmitter<any[]>;
    beforeCreateRow: EventEmitter<any[]>;
    beforeCut: EventEmitter<any[]>;
    beforeDetachChild: EventEmitter<any[]>;
    beforeDrawBorders: EventEmitter<any[]>;
    beforeDropdownMenuSetItems: EventEmitter<any[]>;
    beforeFilter: EventEmitter<any[]>;
    beforeGetCellMeta: EventEmitter<any[]>;
    beforeInit: EventEmitter<any[]>;
    beforeInitWalkontable: EventEmitter<any[]>;
    beforeKeyDown: EventEmitter<any[]>;
    beforeOnCellMouseDown: EventEmitter<any[]>;
    beforeOnCellMouseOut: EventEmitter<any[]>;
    beforeOnCellMouseOver: EventEmitter<any[]>;
    beforePaste: EventEmitter<any[]>;
    beforeRedo: EventEmitter<any[]>;
    beforeRemoveCol: EventEmitter<any[]>;
    beforeRemoveRow: EventEmitter<any[]>;
    beforeRender: EventEmitter<any[]>;
    beforeRenderer: EventEmitter<any[]>;
    beforeRowMove: EventEmitter<any[]>;
    beforeRowResize: EventEmitter<any[]>;
    beforeSetRangeEnd: EventEmitter<any[]>;
    beforeSetRangeStart: EventEmitter<any[]>;
    beforeStretchingColumnWidth: EventEmitter<any[]>;
    beforeTouchScroll: EventEmitter<any[]>;
    beforeUndo: EventEmitter<any[]>;
    beforeValidate: EventEmitter<any[]>;
    beforeValueRender: EventEmitter<any[]>;
    construct: EventEmitter<any[]>;
    hiddenColumn: EventEmitter<any[]>;
    hiddenRow: EventEmitter<any[]>;
    init: EventEmitter<any[]>;
    manualRowHeights: EventEmitter<any[]>;
    modifyAutofillRange: EventEmitter<any[]>;
    modifyCol: EventEmitter<any[]>;
    modifyColHeader: EventEmitter<any[]>;
    modifyColumnHeaderHeight: EventEmitter<any[]>;
    modifyColWidth: EventEmitter<any[]>;
    modifyCopyableRange: EventEmitter<any[]>;
    modifyData: EventEmitter<any[]>;
    modifyRow: EventEmitter<any[]>;
    modifyRowHeader: EventEmitter<any[]>;
    modifyRowHeaderWidth: EventEmitter<any[]>;
    modifyRowHeight: EventEmitter<any[]>;
    modifyRowData: EventEmitter<any[]>;
    modifyTransformEnd: EventEmitter<any[]>;
    modifyTransformStart: EventEmitter<any[]>;
    persistentStateLoad: EventEmitter<any[]>;
    persistentStateReset: EventEmitter<any[]>;
    persistentStateSave: EventEmitter<any[]>;
    skipLengthCache: EventEmitter<any[]>;
    unmodifyCol: EventEmitter<any[]>;
    unmodifyRow: EventEmitter<any[]>;
    constructor(el: ElementRef, _ngZone: NgZone, _hotRegisterer: HotRegisterer, _hotHelper: HotHelper);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    updateHotTable(newSettings: object): void;
    onAfterColumnsChange(): void;
    onAfterColumnsNumberChange(): void;
    addColumn(column: HotColumnComponent): void;
    removeColumn(column: HotColumnComponent): void;
}
